
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Python3分布式爬虫（scrap+redis）基础知识和实战详解 / 憋错料</title>

    <meta name="description" content="Python3分布式爬虫（scrap+redis）基础知识和实战详解 背景 随着业务需求的变化,大规模爬虫遇到各种问题.python爬虫具有先天优势,社区资源比较齐全,各种框架也完美支持.爬虫性能也得到极大提升.本次分享从基础知识入手,涉及python 的两大爬虫框架pyspider.scrapy,并基于scrapy.scrapy-redis 做了分布式爬虫的介绍(直接粘贴的ppt截图)会涉及 redis.mongodb等相关知识. 一.前沿 1.1 爬虫是什么? 网络爬虫(又被称为网页蜘蛛,网络机器人),是一种按照一定的规则,自动的抓取万维网信息的程序或者脚本.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Python3分布式爬虫（scrap+redis）基础知识和实战详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2><strong>背景</strong></h2>
<p>随着业务需求的变化，大规模爬虫遇到各种问题。python爬虫具有先天优势，社区资源比较齐全，各种框架也完美支持。爬虫性能也得到极大提升。本次分享从基础知识入手，涉及python 的两大爬虫框架pyspider、scrapy，并基于scrapy、scrapy-redis 做了分布式爬虫的介绍（直接粘贴的ppt截图）会涉及 redis、mongodb等相关知识。</p>
<h2><strong>一、前沿</strong></h2>
<p><strong>1.1 爬虫是什么？</strong></p>
<p>网络爬虫（又被称为网页蜘蛛，网络机器人），是一种按照一定的规则，自动的抓取万维网信息的程序或者脚本。</p>
<p><strong>1.2 为什么是Python？</strong></p>
<p>简单易学，编写完后可以直接执行，无须编译，代码重用性高，跨平台性。</p>
<h2><strong>二、基础知识</strong></h2>
<p><strong>2.1 Robots协议</strong></p>
<p>Robots 协议也被称作爬虫协议、机器人协议，它的全名叫做网络爬虫排除标准（Robots Exclusion Protocol），用来告诉爬虫和搜索引擎哪些页面可以抓取，哪些不可以抓取。它通常是一个叫做 robots.txt 的文本文件，放在网站的根目录下。</p>
<p>当搜索爬虫访问一个站点时，它首先会检查下这个站点根目录下是否存在 robots.txt 文件，如果存在，搜索爬虫会根据其中定义的爬取范围来爬取。如果没有找到这个文件，那么搜索爬虫便会访问所有可直接访问的页面。</p>
<p><strong>2.2 URL 的含义</strong></p>
<p><em>概念：</em></p>
<p>URL（协议(服务方式) + IP地址(包括端口号) + 具体地址），即统一资源定位符，也就是我们说的网址，统一资源定位符是对可以从互联网上得到的资源的位置和访问方法的一种简洁的表示，是互联网上标准资源的地址。互联网上的每个文件都有一个唯一的URL，它包含的信息指出文件的位置以及浏览器应该怎么处理它。爬虫爬取数据时必须要有一个目标的URL才可以获取数据，</p>
<p><strong>2.3 浏览网页的过程</strong></p>
<p>在用户浏览网页的过程中，我们可能会看到许多好看的图片，比如 <a href="https://link.jianshu.com?t=http%3A%2F%2Fimage.baidu.com%2F" rel="external nofollow noreferrer">http://image.baidu.com/</a> ，我们会看到几张的图片以及百度搜索框，这个过程其实就是用户输入网址之后，经过 DNS 服务器，找到服务器主机，向服务器发出一个请求，服务器经过解析之后，发送给用户的浏览器 HTML、JS、CSS 等文件，浏览器解析出来，用户便可以看到形形色色的图片了，其实就是一次http请求的过程</p>
<p><strong>2.4 代理基本原理</strong></p>
<blockquote><p><strong><em>基本原理</em></strong></p>
<p>在本机和服务器之间搭建了一个桥，此时本机不是直接向 Web 服务器发起请求，而是向代理服务器发出请求，这个过程 Web 服务器识别出的真实的 IP 就不再是我们本机的 IP 了，就成功实现了 IP 伪装，这就是代理的基本原理</p></blockquote>
<blockquote><p><strong><em>代理的作用</em></strong></p>
<p>1、突破自身 IP 访问限制，访问一些平时不能访问的站点</p>
<p>2、访问一些单位或团体内部资源</p>
<p>3、隐藏真实 IP</p></blockquote>
<blockquote><p><strong><em>爬虫代理</em></strong></p>
<p>在爬取过程中可能遇到同一个 IP 访问过于频繁的问题，网站就会让我们输入验证码或登录或者直接封锁 IP，这样会给爬取带来极大的不便。让服务器误以为是代理服务器的在请求自己。这样在爬取过程中通过不断更换代理，就不会被封锁，可以达到很好的爬取效果</p></blockquote>
<blockquote><p><em><strong>代理分类</strong></em></p>
<p>FTP 代理服务器、主要用于访问 FTP 服务器</p>
<p>HTTP 代理服务器，主要用于访问网页</p>
<p>SSL/TLS 代理，主要用于访问加密网站</p></blockquote>
<blockquote><p><strong><em>常见代理设置</em></strong></p>
<p>免费代理</p>
<p>付费代理</p></blockquote>
<h2><strong>三、爬虫入门</strong></h2>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-438a4e7cff27e31a?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong>3.1 常用爬虫库</strong></p>
<p>请求库：requests、selenium(自动化测试工具)+ChromeDrive(chrome 驱动器)、PhantomJS(无界面浏览器)</p>
<p>解析库: LXML(html、xml、Xpath方式)、BeautifulSoup(html、xml)、PyQuery(支持css选择器)、Tesserocr(光学字符识别，验证码)</p>
<p>数据库: mongo、mysql、redis，&nbsp;postgteSQL</p>
<p>存储库: pymysql、pymongo、redispy、RedisDump(Redis 数据导入导出的工具)</p>
<p>web库: Flask(轻量级的 Web 服务程序)、Django</p>
<p>其它工具: Charles(网络抓包工具)</p>
<p><strong>3.2 一个入门栗子</strong></p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-58f82a9fa9b69b04?imageMogr2/auto-orient/strip%7CimageView2/2/w/569/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-ae8493f54bdd85a4?imageMogr2/auto-orient/strip%7CimageView2/2/w/398/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong>3.3 复杂一点的栗子</strong></p>
<p><em>反爬虫：</em></p>
<p>反爬虫，服务器会识别 headers 中的 referer 是不是它自己，如果不是，有的服务器不会响应，所以我们还可以在 headers 中加入 referer等信息</p>
<p><em>反&ldquo;反爬虫&rdquo;</em></p>
<p>1、完全模拟浏览器的工作</p>
<p>2、构造cookie信息</p>
<p>3、设置header信息</p>
<p>4、Proxy 代理设置</p>
<p><em>其它策略</em></p>
<p>Timeout设置</p>
<p><strong>3.4 动态渲染页面抓取</strong></p>
<p>Splash 是一个 JavaScript 渲染服务，是一个带有 HTTP API 的轻量级浏览器，同时它对接了 Python 中的 Twisted 和 QT 库，利用它我们同样可以实现动态渲染页面的抓取。</p>
<p>异步方式处理多个网页渲染过程</p>
<p>获取渲染后的页面的源代码或截图</p>
<p>通过关闭图片渲染或者使用 Adblock 规则来加快页面渲染速度</p>
<p>可执行特定的 JavaScript 脚本</p>
<p>可通过 Lua 脚本来控制页面渲染过程</p>
<p>获取渲染的详细过程并通过 HAR（HTTP Archive）格式呈现</p>
<p><strong>3.5 爬虫完整流程</strong></p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-44f88a2db4fb21f6?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<h2><strong>四、爬虫框架</strong></h2>
<p><strong>4.1 PySpider简介</strong></p>
<p>一个国人编写的强大的网络爬虫系统并带有强大的WebUI。采用Python语言编写，分布式架构，支持多种数据库后端，强大的WebUI支持脚本编辑器，任务监视器，项目管理器以及结果查看器</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-8e158eeb7ac20c4b?imageMogr2/auto-orient/strip%7CimageView2/2/w/404/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong>4.2 PySpider特性</strong></p>
<p>1、python 脚本控制，可以用任何你喜欢的html解析包（内置 pyquery）</p>
<p>2、WEB 界面编写调试脚本，起停脚本，监控执行状态，查看活动历史，获取结果产出</p>
<p>3、数据存储支持MySQL, MongoDB, Redis, SQLite, Elasticsearch; PostgreSQL 及 SQLAlchemy</p>
<p>4、队列服务支持RabbitMQ, Beanstalk, Redis 和 Kombu</p>
<p>5、支持抓取 JavaScript 的页面</p>
<p>6、组件可替换，支持单机/分布式部署，支持 Docker 部署</p>
<p>7、强大的调度控制，支持超时重爬及优先级设置</p>
<p>8、支持python2&amp;3</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-512d04c1a30e1936?imageMogr2/auto-orient/strip%7CimageView2/2/w/398/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-c64d1c873715d845?imageMogr2/auto-orient/strip%7CimageView2/2/w/406/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-f21042136f5fc4a3?imageMogr2/auto-orient/strip%7CimageView2/2/w/406/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong>4.3 Scrapy简介</strong></p>
<p>Scrapy是一个为了爬取网站数据，提取结构性数据而编写的应用框架。 可以应用在包括数据挖掘，信息处理或存储历史数据等一系列的程序中。</p>
<p><strong>4.4 Scrapy运行流程</strong></p>
<p>1、调度器(Scheduler)从待下载链接中取出一个链接(URL)</p>
<p>2、调度器启动采集模块Spiders模块</p>
<p>3、采集模块把URL传给下载器（Downloader），下载器把资源下载下来</p>
<p>4、提取目标数据，抽取出目标对象（Item）,则交给实体管道（item pipeline）进行进一步的处理；比如存入数据库、文本</p>
<p>5、若是解析出的是链接（URL）,则把URL插入到待爬取队列当中</p>
<h2><strong>五、scrapy框架</strong></h2>
<p><strong>5.1 Scrapy基本使用</strong></p>
<p>创建项目：scrapy startproject tutorial</p>
<p>创建spider：scrapy genspider quotes quotes.toscrapy.com</p>
<p>运行项目：scrapy crawl dmoz</p>
<p>交互调试：scrapy shell quotes.toscrape.com</p>
<p>保存数据（多种格式）：scrapy crawl quotes -o quoqes.json</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-33fd2543fd1ad44d?imageMogr2/auto-orient/strip%7CimageView2/2/w/352/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong>5.2 scrapy全局指令</strong></p>
<p>startproject：创建项目</p>
<p>genspider：创建爬虫</p>
<p>settings：获取Scrapy的设定</p>
<p>runspider：在未创建项目的情况下，运行一个编写在Python文件中的spider</p>
<p>shell：以给定的URL(如果给出)或者空(没有给出URL)启动Scrapy shell</p>
<p>fetch：使用Scrapy下载器(downloader)下载给定的URL，并将获取到的内容送到标准输出</p>
<p>view：在浏览器中打开给定的URL，并以Scrapy spider获取到的形式展现</p>
<p>Version：输出Scrapy版本</p>
<p><strong>5.3 scrapy项目指令</strong></p>
<p>crawl：使用spider进行爬取</p>
<p>check：检查项目是否有错</p>
<p>list: 列出当前项目中所有可用的spider，每行输出一个spider</p>
<p>edit：仅仅是提供一个快捷方式。开发者可以自由选择其他工具或者IDE来编写调试spiderparse</p>
<p>parse：获取给定的URL并使用相应的spider分析处理</p>
<p>bench：运行benchmark测试</p>
<p><strong>5.4 scrapy选择器</strong></p>
<p>BeautifulSoup 是在程序员间非常流行的网页分析库，它基于HTML代码的结构来构造一个Python对象， 对不良标记的处理也非常合理，但它有一个缺点：慢。</p>
<p>lxml 是一个基于 ElementTree (不是Python标准库的一部分)的python化的XML解析库(也可以解析HTML)。</p>
<p>Scrapy提取数据有自己的一套机制。它们被称作选择器(seletors)，因为他们通过特定的 XPath 或者 CSS 表达式来&ldquo;选择&rdquo; HTML文件中的某个部分。</p>
<p>XPath 是一门用来在XML文件中选择节点的语言，也可以用在HTML上。</p>
<p>CSS 是一门将HTML文档样式化的语言。选择器由它定义，并与特定的HTML元素的样式相关连。</p>
<p>Scrapy选择器构建于 lxml 库之上，这意味着它们在速度和解析准确性上非常相似。</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-c6d5458b6328e43b?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong>5.5 spiders</strong></p>
<p>Spider类定义了如何爬取某个(或某些)网站。包括了爬取的动作(例如:是否跟进链接)以及如何从网页的内容中提取结构化数据(爬取item)。 换句话说，Spider就是您定义爬取的动作及分析某个网页(或者是有些网页)的地方。</p>
<p>以初始的URL初始化Request，并设置回调函数。 当该request下载完毕并返回时，将生成response，并作为参数传给该回调函数。</p>
<p>spider中初始的request是通过调用 startrequests() 来获取的。 startrequests() 读取 start_urls 中的URL， 并以 parse 为回调函数生成 Request 。</p>
<p>在回调函数内分析返回的(网页)内容，返回 Item 对象、dict、 Request 或者一个包括三者的可迭代容器。 返回的Request对象之后会经过Scrapy处理，下载相应的内容，并调用设置的callback函数(函数可相同)。</p>
<p>在回调函数内，您可以使用 选择器(Selectors) (您也可以使用BeautifulSoup, lxml 或者您想用的任何解析器) 来分析网页内容，并根据分析的数据生成item。</p>
<p>最后，由spider返回的item将被存到数据库(由某些 Item Pipeline 处理)或使用 Feed exports 存入到文件中。</p>
<p><strong><em>属性</em></strong></p>
<p>name: 定义spider名字的字符串(string)</p>
<p>allowed_domains: 包含了 spider 允许爬取的域名(domain)列表(list)</p>
<p>start_urls: URL列表。当没有制定特定的URL时，spider将从该列表中开始进行爬取</p>
<p>custom_settings: 该设置是一个dict.当启动spider时,该设置将会覆盖项目级的设置. 由于设置必须在初始化(instantiation)前被更新,所以该属性 必须定义为class属性</p>
<p>crawler: 该属性在初始化class后,由类方法 from_crawler() 设置, 并且链接了本spider实例对应的 Crawler 对象</p>
<p>settings: crawler 的配置管理器，扩展(extensions)和中间件(middlewares)使用它用来访问 Scrapy 的配置</p>
<p>logger: self.logger.info(‘日志：%s‘, response.status)</p>
<p><strong><em>方法</em></strong></p>
<p>from_crawler: 如果存在，则调用此类方法以从 Crawler 创建 pipeline 实例。它必须返回一个新的pipeline实例。 Crawler 对象提供对所有 Scrapy 核心组件（如settings 和 signals）的访问; 它是 pipeline 访问它们并将其功能挂钩到Scrapy中的一种方法</p>
<p>start_requests: 该方法必须返回一个可迭代对象(iterable)。该对象包含了spider用于爬取的第一个Request</p>
<p>make_requests_from_url: 该方法接受一个URL并返回用于爬取的 Request 对象</p>
<p>parse: 当response没有指定回调函数时，该方法是Scrapy处理下载的response的默认方法</p>
<p>log: 使用 scrapy.log.msg() 方法记录(log)message</p>
<p>closed: 当spider关闭时，该函数被调用</p>
<p><strong>5.6 Item Pipeline</strong></p>
<p>当 Item 在 Spider 中被收集之后，它将会被传递到Item Pipeline，一些组件会按照一定的顺序执行对Item的处理。每个item pipeline组件(有时称之为&ldquo;Item Pipeline&rdquo;)是实现了简单方法的Python类。他们接收到Item并通过它执行一些行为，同时也决定此Item是否继续通过pipeline，或是被丢弃而不再进行处理。</p>
<p>以下是item pipeline的一些典型应用：</p>
<p>1、清理HTML数据</p>
<p>2、验证爬取的数据(检查item包含某些字段)</p>
<p>3、查重(并丢弃)</p>
<p>4、将爬取结果保存到数据库中</p>
<p><strong><em>方法</em></strong></p>
<p>process_item(self, item, spider): 每个item pipeline组件都需要调用该方法，这个方法必须返回一个具有数据的dict，或是 Item (或任何继承类)对象， 或是抛出 DropItem 异常，被丢弃的item将不会被之后的pipeline组件所处理。</p>
<p>open_spider: 当spider被开启时，这个方法被调用。</p>
<p>close_spider: 当spider被关闭时，这个方法被调用</p>
<p>from_crawler: 获取setting 配置信息</p>
<p><strong><em>例子：数据持久化到mongo</em></strong></p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-1c662049022db377?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong>5.7 Downloader Middleware</strong></p>
<p>下载器中间件是介于 Scrapy 的 request/response 处理的钩子框架。 是用于全局修改Scrapy request 和 response 的一个轻量、底层的系统。</p>
<p><strong><em>激活</em></strong></p>
<p>要激活下载器中间件组件，将其加入到DOWNLOADER_MIDDLEWARES 设置中。 该设置是一个字典(dict)，键为中间件类的路径，值为其中间件的顺序(order)。</p>
<p><strong><em>方法</em></strong></p>
<p>1、process_request(request, spider): 当每个request通过下载中间件时，该方法被调用</p>
<p>2、processresponse(request, response, spider): processrequest() 必须返回以下之一: 返回一个 Response 对象、 返回一个 Request 对象或raise一个 IgnoreRequest 异常。如果其返回一个 Response (可以与传入的response相同，也可以是全新的对象)， 该response会被在链中的其他中间件的 process_response() 方法处理。</p>
<p>3、processexception(request, exception, spider): 当下载处理器(download handler)或 processrequest() (下载中间件)抛出异常(包括 IgnoreRequest 异常)时， Scrapy调用 process_exception()</p>
<p><strong><em>例子：添加代理</em></strong></p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-c14de8150c099283?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<h2><strong>六、scrapy 搭建项目</strong></h2>
<p><strong>6.1 爬虫思路</strong></p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-c15f60e30a07d165?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong>6.2 实际项目分析</strong></p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-52d4f02168034d07?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><em>起始页</em></p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-cf2fafce230e5932?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong><em>项目结构</em></strong></p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-a6feb417eace76ed?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<h2><strong>七、分布式爬虫</strong></h2>
<p><strong>7.1 单主机爬虫架构</strong></p>
<p>本机维护一个爬虫队列，scheduler 进行调度</p>
<p><strong>Q：多台主机协作的关键是什么？</strong></p>
<p><strong>A：共享爬虫队列</strong></p>
<p>单主机爬虫架构</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-e9e2a15b70446177?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong>7.2 分布式爬虫架构</strong></p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-99397e4e71f89999?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong><em>分布式爬虫架构</em></strong></p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-ce1a4e0ae0b2debd?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong>7.3 问题</strong></p>
<p><strong><em>Q1：队列怎么选？</em></strong></p>
<p><strong>A1: Redis队列</strong></p>
<p>Redis 非关系型数据库，key-value形式存储，结构灵活</p>
<p>是内存中的数据结构存储系统，处理速度快，性能好</p>
<p>提供队列、集合等多种存储结构，方便队列维护</p>
<p><strong><em>Q2：怎么去重？</em></strong></p>
<p><strong>A2：Redis集合</strong></p>
<p>Redis 提供集合数据结构，在redis集合中存储每个request的指纹</p>
<p>在向redis集合中存储request指纹的时候，先验证指纹是否存在？</p>
<p>[如果存在]：则不添加request到队列</p>
<p>[不存在]：则将request加入队列，并将指纹加入集合</p>
<p><strong><em>Q3：怎样防止中断？</em></strong></p>
<p><strong>A3：启动判断</strong></p>
<p>在每台从机 scrapy 启动时 都会首先判断当前 redis reqeust队列是否为空</p>
<p>[不为空]：从队列中取得下一个 request ，进行执行爬虫</p>
<p>[空]：重新开始爬取，第一台从机执行爬取向队列中添加request</p>
<p><strong><em>Q4：怎样实现该架构？</em></strong></p>
<p><strong>A4：Scrapy-Redis</strong></p>
<p>scrapy是Python的一个非常好用的爬虫框架，功能非常强大，但是当我们要爬取的页面非常多的时候，单个主机的处理能力就不能满足我们的需求了（无论是处理速度还是网络请求的并发数），这时候分布式爬虫的优势就显现出来，人多力量大。而scrapy-Redis就是结合了分布式数据库redis，重写了scrapy一些比较关键的代码（scrapy的调度器、队列等组件），将scrapy变成一个可以在多个主机上同时运行的分布式爬虫。</p>
<p>github地址：<a href="https://link.jianshu.com?t=https%3A%2F%2Fgithub.com%2Frmax%2Fscrapy-redis" rel="external nofollow noreferrer">https://github.com/rmax/scrapy-redis</a></p>
<p><strong>7.4 源码解读</strong></p>
<p>阅读源码前：需要了解 scrapy 的运行原理，否则并没什么用。</p>
<p>scrapy-redis 工程的主体还是 redis 和 scrapy 两个库，将两个库的核心功能结合，实现分布式。</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-94624d1d06668b8e?imageMogr2/auto-orient/strip%7CimageView2/2/w/640/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong><em>1 connection.py</em></strong></p>
<p>负责根据setting中配置实例化redis连接。被dupefilter和scheduler调用，总之涉及到redis存取的都要使用到这个模块</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-50a8be7919fffa2f?imageMogr2/auto-orient/strip%7CimageView2/2/w/389/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong><em>2 dupefilter.py</em></strong></p>
<p>通过继承 BaseDupeFilter 重写他的方法，实现了基于redis的 request 判重。scrapy-redis使用 redis的一个 set 中插入 fingerprint（不同spider的key不同）</p>
<p>spider名字+DupeFilter的key就是为了在不同主机上的不同爬虫实例，只要属于同一种spider，就会访问到同一个set，而这个set就是他们的url判重池 。</p>
<p>DupeFilter 判重会在 scheduler 类中用到，每一个request在进入调度之前都要进行判重，如果重复就不需要参加调度，直接舍弃就好了</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-a25c857b199664e0?imageMogr2/auto-orient/strip%7CimageView2/2/w/388/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong><em>3 picklecompat.py</em></strong></p>
<p>loads 和 dumps 两个函数，其实就是实现了一个 serializer，因为 redis 数据库不能存储复杂对象（value部分只能是字符串，字符串列表，字符串集合和hash，key部分只能是字符串），所以存储前需要先序列化成文本才行</p>
<p>这个 serializer 主要用于 scheduler 存 reuqest 对象。</p>
<p>为什么不用json格式?（item pipeline 的串行化默认用的就是 json）</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-aeec3981e8857769?imageMogr2/auto-orient/strip%7CimageView2/2/w/385/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong><em>4 pipelines.py</em></strong></p>
<p>pipeline 文件实现了一个 item pipieline 类，和 scrapy 的 item pipeline 是同一个对象，从settings中获取我们配置的REDISITEMSKEY作为key，把item串行化之后存入redis数据库对应的value中（这个value是list，我们的每个item是这个list中的一个结点），这个pipeline把提取出的item存起来，主要是为了方便我们延后处理数据。</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-6b6accf7d2121613?imageMogr2/auto-orient/strip%7CimageView2/2/w/384/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong><em>5 queue.py</em></strong></p>
<p>这里实现了三种方式的 Queue</p>
<p>SpiderQueue(队列)：先进先出</p>
<p>SpiderStack(栈)：先进后出</p>
<p>SpiderPriorityQueue(优先级队列)</p>
<p>这些容器类都会作为scheduler调度request的容器，scheduler在每个主机上都会实例化一个，并且和spider一一对应，所以分布式运行时会有一个spider的多个实例和一个scheduler的多个实例存在于不同的主机上，但是，因为scheduler都是用相同的容器，而这些容器都连接同一个redis服务器，又都使用spider名加queue来作为key读写数据，所以不同主机上的不同爬虫实例公用一个request调度池，实现了分布式爬虫之间的统一调度。</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-55b4e46ec42c3053?imageMogr2/auto-orient/strip%7CimageView2/2/w/386/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong><em>6 scheduler.py</em></strong></p>
<p>重写了scheduler类，代替scrapy.core.scheduler 的原有调度器，对原有调度器的逻辑没有很大的改变，主要是使用了redis作为数据存储的媒介，以达到各个爬虫之间的统一调度。scheduler负责调度各个spider的request请求，scheduler初始化时，通过settings文件读取queue和dupefilters的类型，配置queue和dupefilters使用的key。每当一个request要被调度时，enqueuerequest被调用，scheduler使用dupefilters来判断这个url是否重复，如果不重复，就添加到queue的容器中（可以在settings中配置）。当调度完成时，nextrequest被调用，scheduler就通过queue容器的接口，取出一个request，把他发送给相应的spider，让spider进行爬取工作。</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-faa9035fcd71649c?imageMogr2/auto-orient/strip%7CimageView2/2/w/388/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>
<p><strong><em>7 spider.py</em></strong></p>
<p>设计的这个spider从redis中读取要爬的url,然后执行爬取，若爬取过程中返回更多的url，那么继续进行直至所有的request完成。之后继续从redis中读取url，循环这个过程。</p>
<p>分析：在这个spider中通过connect signals.spideridle信号实现对crawler状态的监视。当idle时，返回新的makerequestsfromurl(url)给引擎，进而交给调度器调度。</p>
<p><img src="//upload-images.jianshu.io/upload_images/11994763-364bbf0eda07c316?imageMogr2/auto-orient/strip%7CimageView2/2/w/384/format/webp" /><img src="image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" />?</p>

<p>原文地址：https://www.cnblogs.com/rrh4869/p/11175377.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-10 18:07:03 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e5%af%b9%e8%b1%a1/" title="对象">对象</a>, <a href="https://www.biecuoliao.com/tag/href/" title="href">href</a>, <a href="https://www.biecuoliao.com/tag/%e8%b6%85%e6%97%b6/" title="超时">超时</a>, <a href="https://www.biecuoliao.com/tag/%e7%82%b9%e5%87%bb/" title="点击">点击</a>, <a href="https://www.biecuoliao.com/tag/header/" title="header">header</a>, <a href="https://www.biecuoliao.com/tag/%e7%bd%91%e7%ab%99/" title="网站">网站</a>, <a href="https://www.biecuoliao.com/tag/%e5%9f%ba%e7%a1%80/" title="基础">基础</a>, <a href="https://www.biecuoliao.com/tag/sqli/" title="sqli">sqli</a>, <a href="https://www.biecuoliao.com/tag/ise/" title="ise">ise</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Python3分布式爬虫（scrap+redis）基础知识和实战详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLxErWM.html" rel="bookmark">Linux基础知识之挂载详解（mount&comma;umount及开机自动挂载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux基础知识之挂载详解(mount,umount及开机自动挂载) 转载自:http://www.linuxidc.com/Linux/2016-08/134666.htm 挂载概念简述: 根文件系统之外的其他文件要想能够被访问,都必须通过&quot;关联&quot;至根文件系统上的某个目录来实现,此关联操作即为&quot;挂载&quot;,此目录即为&quot;挂载点&quot;,解除此关联关系的过程称之为&quot;卸载&quot; 1.挂载:根文件系统外通过关联至根文件系统上的某个目录来实现访问			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O8Y5o4.html" rel="bookmark">学习笔记-《Linux基础知识之挂载详解（mount&comma;umount及开机自动挂载）》</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;Linux基础知识之挂载详解(mount,umount及开机自动挂载)&gt;来源:Linux社区  作者:chawan 原文链接 http://www.linuxidc.com/Linux/2016-08/134666.htm 以下是学习作者这篇文章做的一些摘要及学习体会. 重要概念(经典原文引述) 挂载概念简述: 根文件系统之外的其他文件要想能够被访问,都必须通过&quot;关联&quot;至根文件系统上的某个目录来实现,此关联操作即为&quot;挂载&quot;,此目录即为&quot;挂载点			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPO7kz4.html" rel="bookmark">Android自定义view教程05--自定义view的基础知识之LayoutInflater详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面的教程我们讲了一下android的动画 的使用,尤其是着重讲解了属性动画的使用.那么这章开始我们将会讲一下android 自定义view的一些基础知识.帮助大家理解. 首先我们来关注一下LayoutInflater这个类,经常使用开源控件的人对这个类应该很熟悉了,但是很少有人能把这个类讲明白 用清楚,今天我们就来深挖一下这个类. 首先我们定义一个button.xml 和button2.xml 1 &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyDpEn4.html" rel="bookmark">DNS与BIND学习笔记-基础知识及配置详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自 http://blog.chinaunix.net/uid-14825809-id-333591.html 标签:DNS 多线 智能 服务器 bind 一直想系统的学习和了解DNS的原理,包括看相关的rfc文件,一看和dns相关的rfc文件,妈呀,居然有86个之多.能看多少是多少吧.先把DNS的原理研究透彻了.在看rfc文件我想会事半功倍的:) 1. ICANN是干什么的?和他的一些相关资讯? ICANN全称是叫:Internet Corporation for Assigned Name			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXoD1z4.html" rel="bookmark">history基础知识及命令详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.概述 history命令是Linux的一个内嵌的shell命令,history命令的使用有时会大大缩短我们输入命令的时间,达到节省命令快捷操作的要求.学会history命令之后,我们可以隐藏一些含有敏感信息的命令输入,做到使系统更加安全的目的.我们还可以定时的去清理我们不想要其它用户看到的一些私密的命令. 二.命令行历史 保存你输入的命令历史.可以用它来重复执行命令: 登录shell时,会读取命令历史文件中记录下的命令,历史文件路径~/.bash_history: 登录进shell后新执行的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgyRrn3.html" rel="bookmark">文件管理基础知识及命令详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.文件系统概述 1.文件和目录被组织成一个单根倒置树结构: 2.文件系统从根目录下开始,用&quot;/&quot;表示: 3.名称是大小写敏感: 4.以.开头的文件为隐藏文件: 5.路径分隔的/: 6.文件有两位数据: 6.1:元数据(文件名.大小属性等):metadata: 数据:data: 二.文件名命名规则 1.包括路径在内文件名称最长4095个字节,用/分隔的路径不能超过255个字节: 2.文件名除了/以外的任意字符,但不建议使用特殊字符,有些字符需要引号来引用它们: 3.标准Linux文件系			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVNYAkM.html" rel="bookmark">OpenStack基础知识-tox的详解介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.tox简介 tox是通用的虚拟环境管理和测试命令行工具.tox能够让我们在同一个Host上自定义出多套相互独立且隔离的python环境,每套虚拟环境中可能使用了不同的 Python 拦截器/环境变量设置/第三方依赖包.所以 tox 最典型的应用就是用于测试 Python 程序的兼容性了.tox是openstack社区最基本的测试工具,比如python程序的兼容性.UT等. 它的目标是提供最先进的自动化打包.测试和发布功能. 1)作为持续集成服务器的前端,大大减少测试工作所需时间: 2)检查软			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eZYWb3.html" rel="bookmark">python基础知识（列表详解）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				列表(list) 列表中可以存入整数.实数.布尔值.字符串.序列.对象 可变序列 列表  []  元素间隔用   ,号分隔 列表的创建和删除 使用赋值运算符直接创建列表 listname = [元素1,元素2,.......] 创建空列表 列表名 = [] 创建数值列表 string = &quot;圣人蛋糕&quot; list(string) print(string) [&quot;圣&quot;,&quot;人&quot;,&quot;蛋&quot;,&quot;高&quot;] range()			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmDzYX4.html" rel="bookmark">C&num;反射基础知识和实战应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先来说一下什么是反射? 反射提供了封装程序集.模块和类型的对象(Type类型) 可以使用反射动态的创建类型的实例,将类型绑定到现有对象,或从现有对象中获取类型,然后,可以调用类型的方法或访问其字段和属性 . 总之,有了反射,以前很多实现不了的功能都可以实现. 下面先来写一个小例子,体验一下反射是怎么一回事: 打开VS2010,新建一个控制台应用程序,在program.cs里面写代码 首先引入命名空间: using System.Reflection; 下如下代码: PropertyInfo l			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JDdJD0.html" rel="bookmark" class="title">Majority Element II</a>
					<div>
						Given an integer array of size n, find all elements that appear more than ⌊ n/3 ⌋ times. The algorit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWy8W63.html" rel="bookmark" class="title">App Distribution Guide &lpar;二&rpar;</a>
					<div>
						Configuring Your Xcode Project for Distribution  You can edit your project settings anytime, but som ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qQblP3.html" rel="bookmark" class="title">Hibernate查询uodate-megre-saveorupdate-delete方法使用</a>
					<div>
						update这个方法的使用1:先加载然后再修改 /** * 修改通过get方法获得的持久化对象 */ private static void update1() { Configuration con ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4ARYPdM.html" rel="bookmark" class="title">ECSHOP使用第三方WEBAPI来发送邮件</a>
					<div>
						由于服务器商禁用了SMTP,所有到网上找了一个邮件代理商.http://www.mandrill.com/ 修改lib_base.php 将此函数原有的内容注释掉,用下面的方法进行替换.即可绕过服务器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nklxx3.html" rel="bookmark" class="title">模板&mdash;&mdash;BigInteger</a>
					<div>
						1 #include &lt;iostream&gt; 2 #include &lt;cstring&gt; 3 #include &lt;string&gt; 4 #include &lt;vect ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGpyOQ0.html" rel="bookmark" class="title">OpenSSL&period;Net 在生产环境中无法正常加载的原因分析与解决 z</a>
					<div>
						http://blog.csdn.net/wangjia184/article/details/6990098 http://www.openssl.org/ 在本地测试好好的代码部署到生产环境后,遇 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JdZ9b0.html" rel="bookmark" class="title">Python Falling back to the &amp;&num;39&semi;python&amp;&num;39&semi; engine because the &amp;&num;39&semi;c&amp;&num;39&semi; engine does not support regex separators</a>
					<div>
						O'Reilly出版的Wes McKinney编的&lt;Python for Data Analysis&gt; 本人使用工具: PyCharm 2016.3.2 警告:ParserWarning: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jejXDM.html" rel="bookmark" class="title">《Linux内核设计与实现》Chapter 5 读书笔记</a>
					<div>
						&lt;Linux内核设计与实现&gt;Chapter 5 读书笔记 在现代操作系统中,内核提供了用户进程与内核进行交互的一组接口,这些接口的作用是: 使应用程序受限地访问硬件设备 提供创建新进程与已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41zjKvM.html" rel="bookmark" class="title">你会被机器抢去饭碗吗</a>
					<div>
						1 上课时我常对学生讲:“你们在未来找工作的时候,一定要避免做那些很容易被电脑或机器人取代的工作.Computer这个词,最早指的是一种职业,就是那种做计算工作的人.现在早就被淘汰,没人知道了.我在上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVq69x4.html" rel="bookmark" class="title">【java开发系列】&mdash;&mdash; 常用SQL语句</a>
					<div>
						创建表 create table emp( id decimal, name char(10), age decimal) 删除表 DROP TABLE EMP 插入默认值 CREATE TABLE  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J9kqn3.html" rel="bookmark" class="title">MarkdownPan2 简单使用指南</a>
					<div>
						markdown 简单使用指南 一级标题 二级标题 三级标题加代码 四级标题 这里是加粗 这里是正文and English 888 这里有正文嵌入代码这种样式 这里是代码块 这种使用的代码块 还有引用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJxlv3.html" rel="bookmark" class="title">USB Type-C 接口有什么优点？</a>
					<div>
						USB Type-C 接口有什么优点? 提到USB Type-C接口(以下简称为USB-C),大家第一个能想到的是USB-C接口能正反插,用起来很舒服.了解更多的可能还支持USB-C接口速度更快, 达 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dzyvr4.html" rel="bookmark" class="title">前端异常监控 - BadJS</a>
					<div>
						前端异常监控 - BadJS 简介:BadJS 是 web 前端异常监控解决方案,提供一种 web 页面的脚本错误监控.上报.统计.查看等系统化的跟踪解决方案.目前BadJS覆盖了腾讯课堂.公众号.邮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nRx9x0.html" rel="bookmark" class="title">List集合分组</a>
					<div>
						1 var ArticleList = new Services.Data.SearchService().GetArticleBaseList(ref param); 2 IEnumerable&l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME6LgZ0.html" rel="bookmark" class="title">hdu 4111 Alice and Bob 记忆化搜索 博弈论</a>
					<div>
						Alice and Bob Time Limit: 20 Sec  Memory Limit: 256 MB 题目连接 http://acm.hdu.edu.cn/showproblem.php?pi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41GaVk0.html" rel="bookmark" class="title">js input监听兼容事件</a>
					<div>
						$('#phoneNumber').on('input',function() { var valueP = $(this).attr('value'); if(valueP.length == 11 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RQAzjM.html" rel="bookmark" class="title">nodejs之memcache连接池应用方法</a>
					<div>
						花了二天时间才测试成功 NODEJS技术太新了点 中英文的资料都少 所以记录下正确的nodejs之memcache连接池应用方法方便后来人 按理说memcached应该自带有连接池 但是不知道为什么总 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLQqEv0.html" rel="bookmark" class="title">类Dota2服务器架构</a>
					<div>
						类Dota2服务器架构构思 Game Login Server游戏登陆服务器: 负责账号密码验证,游戏负载,短链接,验证成功后,客户端连接相应GameServer,断开LoginServer,处理其他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZedVg0.html" rel="bookmark" class="title">影响信息传播的可计算因素分析</a>
					<div>
						网络的连通性 网络的连通性对信息传播(传播速度.扩散规模)有较大影响. 度相关性:一条边连接的两个节点度值之间的相关性(一般使用度值的Pearson相关系数来刻画) 度大节点趋于和度大节点相连,则该网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lLApZ0.html" rel="bookmark" class="title">Struts 路径分析以及是否一定要执行excute&lpar;&rpar;方法</a>
					<div>
						一.Struts路径分析. 1.先创建 Struts_PathAction 继承至 ActionSupport ,设置execute()方法的返回值是&quot;path&quot;. public  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
